import db from '../db.js';

class UserService {
    async add(username, password) {
        return (await db.query("INSERT INTO users (username, password) VALUES ($1, $2) RETURNING id", [username, password])).rows[0].id;
    }
    
    async get_by_username(username) {
        return (await db.query("SELECT *  FROM users WHERE username = $1", [username])).rows[0];
    }

    async get_stats(user_id) {
        return {
            my_count: (await db.query("SELECT COUNT(*) FROM captchas WHERE submitter = $1", [user_id])).rows[0].count,
            top_five: (await db.query("select username, (select count(*) from captchas where submitter = users.id) from users JOIN captchas on submitter = users.id GROUP BY users.id ORDER BY count DESC LIMIT 5")).rows
        };
    }
}

export default new UserService();